#include "Ti86.inc"

Str_Buffer	equ	$ca00
Factor_Start_CurPos	equ	$1100

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db " Divisibility Tester ",0

ProgStart:
	call _runindicoff
	call _homeup
	call _clrLCD
	call _flushallmenus
	ld hl,Factor_Start_CurPos
	ld (_penCol),hl
	set textInverse,(iy+textflags)
	ld hl,ShellTitle
	call _puts
	res textInverse,(iy+textflags)
	ld hl,Str_Buffer
Get_Str_Loop:
	push hl
	ld a,Lunderscore
	call _putmap
Get_Str_Key_Loop:
	call _getkey
	pop hl
	cp kExit
	jp z,_clrLCD
	cp kEnter
	jr z,End_Get_Str
	cp kDel
	jp z,Del_Char
	cp k0
	jr c,Get_Str_Key_Loop
	cp k9+1
	jr nc,Get_Str_Key_Loop
	sub k0
	ld (hl),a
	inc hl
	push hl
	add a,L0
	call _putc
	pop hl
	jr Get_Str_Loop
End_Get_Str:
	push hl
	ld a,Lspace
	call _putmap
	pop hl
	dec hl
	ex de,hl	;pointer in de, temp mult in hl, sum in bc
Str_To_Num_In_BC:
	ld a,(de)
	ld c,a
	ld b,0
;
	dec de
	call Check_End_Str
	ld a,(de)
	ld l,a
	ld h,0
	push bc
	call _mulHL10
	pop bc
	add hl,bc
	push hl
	pop bc
;
	dec de
	call Check_End_Str
	ld a,(de)
	ld l,a
	ld h,0
	push bc
	call _mulHL10
	call _mulHL10
	pop bc
	add hl,bc
	push hl
	pop bc
	dec de
	call Check_End_Str
	ld a,(de)
	ld l,a
	ld h,0
	push bc
	call _mulHL10
	call _mulHL10
	call _mulHL10
	pop bc
	add hl,bc
	push hl
	pop bc
	dec de
	call Check_End_Str
	ld a,(de)
	ld l,a
	ld h,0
	push bc
	call _mulHL10
	call _mulHL10
	call _mulHL10
	call _mulHL10
	pop bc
	add hl,bc
	push hl
	pop bc
Num_In_BC:
	push bc
	pop de
Find_Factors_Loop:	;Number to be tested in bc, temp sum in hl, user's num in de
	ld hl,$0000
Inner_Loop:
	add hl,bc
	call _cphlde
	jr c,Inner_Loop
	call z,Disp_Num
	dec bc
	ld hl,$0001
	sbc hl,bc
;	inc hl
	jr nz,Find_Factors_Loop
	jp _pause	

Disp_Num:
	push de
	push bc
	push bc
	pop hl
	call DisplayHL
	ld hl,_penRow				;_vnewline {
	ld a,(hl)
	add a,6
	cp 64-6						;(exception)
	jr nc,Disp_Num_NewScreen	;(exception)
	ld (hl),a
	dec hl
	ld (hl),0					;}
	pop bc
	pop de
	ret
Disp_Num_NewScreen:
	call _getkey
	cp kExit
	jp z,_jforcecmdnochar
	call _clrLCD
	ld hl,$0000
	ld (_penCol),hl
	pop bc
	pop de
	ret

Check_End_Str:
	ld a,e
	cp $ff
	ret nz
	pop hl
	jr Num_In_BC

Del_Char:
	dec hl
	push hl
	ld a,Lspace
	call _putmap
	ld hl,_curCol
	dec (hl)
	pop hl
	jp Get_Str_Loop

;====================================================================
; DisplayHL:  (idea from SCaBBy/Mardell)    [Assembly Coder's Zenith]
;  Display HL as a 5-digit decimal number with no leading zeros
;  out: AF, HL, BC, DE destroyed
;====================================================================
DisplayHL:
 ld c,'0'  				; save ascii value for zero
 ld de,_OP1+5			; point to end of the buffer
 xor a				; zero terminate string
 ld (de),a				; set last byte to zero
DisplayHLl:
 call _divHLby10		; next digit
 dec de				; next position
 add a,c				; convert to ascii
 ld (de),a				; save digit
 ld a,h				; load upper byte
 or l					; check with lower byte for zero
 jr nz,DisplayHLl			; loop
 ex de,hl				; point to buffer
 jp _vputs			; print number, we're done

.end
